<template>
  <div class="home">
    <v-row class="ma-4">
      <v-col class="home">
        <h1 style="text-decoration: underline">Tests</h1>
      </v-col>
    </v-row>
    <v-row class="ma-4">
      <v-col cols="5">
        <h3>Press to trigger pipeline</h3>
      </v-col>
      <v-col>
        <v-btn
            outlined
            color="indigo"
            @click="dialog=true"
        >
          Test
        </v-btn>
        <v-dialog
            v-model="dialog"
            persistent
            width="500"
        >
          <v-card @click="dialog=false" class="d-inline-flex justify-space-between pa-4">
            <v-card-title class="headline ma-4 px-4 py-0">Pipeline is triggered!</v-card-title>
            <v-btn
                color="blue"
                class="ma-4 pa-2"
                text
                @click="Trigger(); dialog=false"
            >
              Ok
            </v-btn>
          </v-card>
        </v-dialog>
      </v-col>
    </v-row>
    <v-row class="ma-4">
      <v-col cols="5">
        <h3>Show some information about pipeline</h3>
      </v-col>
      <v-col cols="2">
        <v-btn
            outlined
            color="indigo"
            @click="show=!show"
        >
          Show
        </v-btn>
      </v-col>
      <v-col>
        <v-btn
            outlined
            color="indigo"
        >
          <router-link to="/information" style="text-decoration: none">Information</router-link>
        </v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col v-for="pipeline in CountSize()" :key="pipeline.id" cols="4">
        <v-card
            class="ma-4"
            max-width="344"
        >
          <div class="card pa-4" v-show="!show">
            <v-img :src='PipelinesImg(pipeline-1)' height="200px"></v-img>
            <v-card-title>
              {{ PipelinesTitle(pipeline - 1) }}
              <v-spacer></v-spacer>
              {{ PipelinesId(pipeline - 1) }}
            </v-card-title>
            <v-card-subtitle>
              {{ PipelinesSubtitle(pipeline - 1) }}
            </v-card-subtitle>
            <v-divider></v-divider>
            <v-card-text>
              {{ PipelinesText(pipeline - 1) }}
            </v-card-text>
          </div>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import {Post_Trigger} from "../../Trigger";

let data = require('../../report.json');
let size = Object.keys(data.pipelines.id).length;
export default {
  name: 'Home',
  data: () => ({
    show: true,
    dialog: false,
  }),
  methods: {
    CountSize() {
      let count = 0;
      for (let i = 0; i < size; i++) {
        count++;
      }
      return count;
    },
    Trigger() {
      Post_Trigger();
    },
    PipelinesTitle(index) {
      return data.pipelines.titles[index];
    },
    PipelinesSubtitle(index) {
      return data.pipelines.subtitles[index];
    },
    PipelinesText(index) {
      return data.pipelines.text[index];
    },
    PipelinesImg(index) {
      return data.pipelines.img[index];
    },
    PipelinesId(index) {
      return data.pipelines.id[index];
    }
  }
}
</script>
